local CWalkingLandUnit = import('/lua/cybranunits.lua').CWalkingLandUnit
local Weapon = import('/lua/sim/Weapon.lua').Weapon
local cWeapons = import('/lua/cybranweapons.lua')
local CDFLaserDisintegratorWeapon = cWeapons.CDFLaserDisintegratorWeapon01
local CDFElectronBolterWeapon = cWeapons.CDFElectronBolterWeapon
local MissileRedirect = import('/lua/defaultantiprojectile.lua').MissileRedirect

local EMPDeathWeapon = Class(Weapon) {
    OnCreate = function(self)
        Weapon.OnCreate(self)
        self:SetWeaponEnabled(false)
    end,

    OnFire = function(self)
        local blueprint = self:GetBlueprint()
        DamageArea(self.unit, self.unit:GetPosition(), blueprint.DamageRadius,
                   blueprint.Damage, blueprint.DamageType, blueprint.DamageFriendly)
    end,
}

URL_LH = Class(CWalkingLandUnit) 
{
    PlayEndAnimDestructionEffects = false,

    Weapons = {
        Disintigrator = Class(CDFLaserDisintegratorWeapon) {},
        RightDisintigrator = Class(CDFLaserDisintegratorWeapon) {},
        LeftHeavyBolter = Class(CDFElectronBolterWeapon) {},
        RightHeavyBolter = Class(CDFElectronBolterWeapon) {},
        EMP = Class(EMPDeathWeapon) {},
        TorsoTarget = Class(CDFLaserDisintegratorWeapon) {},
    },
    
#    OnStopBeingBuilt = function(self,builder,layer)
#        CWalkingLandUnit.OnStopBeingBuilt(self,builder,layer)
#        local antiMissile = MissileRedirect {
#            Owner = self,
#            Radius = 5,
#            AttachBone = 'Turret_Muzzle',
#        }
#        self.Trash:Add(antiMissile)
#        self.UnitComplete = true
#    end,

    OnKilled = function(self, instigator, type, overkillRatio)
        local emp = self:GetWeaponByLabel('EMP')
        local bp
        for k, v in self:GetBlueprint().Buffs do
            if v.Add.OnDeath then
                bp = v
            end
        end 
        if bp == nil then return end
        
            
        #Apply Buff
		self:AddBuff(bp)
		if self.UnitComplete then
            # Play EMP Effect
            CreateLightParticle( self, -1, -1, 24, 62, 'flare_lens_add_02', 'ramp_red_10' )
            # Fire EMP weapon
            emp:SetWeaponEnabled(true)
            emp:OnFire()
        end
        CWalkingLandUnit.OnKilled(self, instigator, type, overkillRatio)
    end,
}

TypeClass = URL_LH